<?php

namespace seraph_pds;

if( !defined( 'ABSPATH' ) )
	exit;

require( 'Cmn/Gen.php' );
require( 'Cmn/Ui.php' );
require( 'Cmn/Fs.php' );

require( 'Cmn/Plugin.php' );

const PLUGIN_SETT_VER								= 1;
const PLUGIN_DATA_VER								= 1;
const PLUGIN_EULA_VER								= 1;

function GetPostsAvailableCategories( $postTypes = NULL )
{
	if( empty( $postTypes ) )
		$postTypes = GetCompatiblePostsTypes();
	return( Wp::GetPostsAvailableTaxonomies( Wp::POST_TAXONOMY_TYPE_CATEGORY, $postTypes ) );
}

function GetCompatiblePostsTypes()
{
	return( Wp::GetSupportsPostsTypes( array( 'editor', 'thumbnail' ) ) );
}

const ShowOperateOptionsMode_Post				= 1;
const ShowOperateOptionsMode_Settings			= 2;
const ShowOperateOptionsMode_Batch_Operate		= 3;
const ShowOperateOptionsMode_Batch_Settings		= 4;
const ShowOperateOptionsMode_Batch_Report		= 5;

function _post_is_new( $post )
{
	return( 'auto-draft' === $post -> post_status );
}

function _ShowOperateOptions( $mode, $post = NULL )
{
	$rmtCfg = PluginRmtCfg::Get();
	$sett = Plugin::SettGet();

	$availablePlugins = Plugin::GetAvailablePlugins();

	if( $mode == ShowOperateOptionsMode_Settings )
	{
		$licHtmlContent = Plugin::GetLockedFeatureLicenseContent( Plugin::DisplayContent_Block, '', vsprintf( _x( 'LockedFeatureInfo_%1$s%2$s%3$s%4$s', 'admin.Settings_ContentConversion', 'seraphinite-post-docx-source' ), Gen::ArrFlatten( array( Ui::Link( Ui::Tag( 'strong', array( '', '' ) ), Gen::GetArrField( $rmtCfg, 'LicCont.UrlPostCnvSettings' ), true ), Ui::Tag( 'strong', array( '', '' ) ) ) ) ) );
		if( !empty( $licHtmlContent ) )
			echo( Ui::Tag( 'p', $licHtmlContent ) . Ui::Tag( 'p', null, array( 'class' => array( 'hndle' ) ) ) );
	}

	if( $mode == ShowOperateOptionsMode_Batch_Settings )
	{
		$licHtmlContent = Plugin::GetLockedFeatureLicenseContent();
		if( !empty( $licHtmlContent ) )
			echo( Ui::Tag( 'p', $licHtmlContent ) . Ui::Tag( 'p', null, array( 'class' => array( 'hndle' ) ) ) );
	}

	$postIsNew = empty( $post ) ? false : _post_is_new( $post );

	$aPostTypes = array();
	if( $mode != ShowOperateOptionsMode_Post )
		$aPostTypes = GetCompatiblePostsTypes();

	$settBlockClass = array();
	if( $mode != ShowOperateOptionsMode_Settings )
		$settBlockClass = array( 'compact' );

	if( $mode == ShowOperateOptionsMode_Post || $mode == ShowOperateOptionsMode_Batch_Operate )
	{
		echo( Ui::TagOpen( 'input', array( 'type' => 'hidden', 'id' => 'seraph_pds_site_addr', 'value' => Gen::SetLastSlash( get_site_url(), false ) ), true ) );
		echo( Ui::TagOpen( 'input', array( 'type' => 'hidden', 'id' => 'seraph_pds_site_name', 'value' => Gen::GetSiteDisplayName() ), true ) );
		echo( Ui::TagOpen( 'input', array( 'type' => 'hidden', 'id' => 'seraph_pds_mediaUploadUri', 'value' => Wp::GetMediaUploadUrl( null, true ) ), true ) );
		echo( Ui::TagOpen( 'input', array( 'type' => 'hidden', 'id' => 'seraph_pds_helper_request_url', 'value' => Plugin::GetAdminApiUri() ), true ) );
		echo( Ui::TagOpen( 'input', array( 'type' => 'hidden', 'id' => 'seraph_pds_posts_avail_cats', 'value' => urlencode( wp_json_encode( GetPostsAvailableCategories( empty( $post ) ? NULL : array( $post -> post_type ) ) ) ) ), true ) );
		echo( Ui::TagOpen( 'input', array( 'type' => 'hidden', 'id' => 'seraph_pds_avail_langs', 'value' => urlencode( wp_json_encode( Wp::GetLangs() ) ) ), true ) );

		if( $mode == ShowOperateOptionsMode_Post )
		{
			echo( Ui::TagOpen( 'input', array( 'type' => 'hidden', 'id' => 'seraph_pds_postType', 'value' => $post -> post_type ), true ) );
			echo( Ui::TagOpen( 'input', array( 'type' => 'hidden', 'id' => 'seraph_pds_upload-post-url', 'value' => get_permalink( $post ) ), true ) );
			echo( Ui::TagOpen( 'input', array( 'type' => 'hidden', 'id' => 'seraph_pds_avail_plugins', 'value' => urlencode( wp_json_encode( $availablePlugins ) ) ), true ) );

			echo( Ui::InputBox( 'file', 'seraph_pds_upload', null, array( 'style' => array( 'display' => 'none' ), 'accept' => '.docx', 'onchange' => 'seraph_pds_filename.value = this.files.length ? this.files[ 0 ].name : \'\';' ) ) );
		}

		echo( Ui::InputBox( 'file', 'seraph_pds_uploadMedias', null, array( 'multiple' => '', 'webkitdirectory' => '', 'style' => array( 'display' => 'none' ), 'onchange' => 'seraph_pds_uploadMediasPath.value = this.files.length ? seraph_pds.Gen.GetFileDir( this.files[ 0 ].webkitRelativePath, false, -1 ) : \'\';' ) ) );

		if( $mode == ShowOperateOptionsMode_Batch_Operate )
		{
			echo( Ui::InputBox( 'file', 'seraph_pds_upload', null, array( 'style' => array( 'display' => 'none' ), 'accept' => '.docx', 'multiple' => '', 'onchange' => '' ) ) );
			echo( Ui::InputBox( 'file', 'seraph_pds_uploadDir', null, array( 'style' => array( 'display' => 'none' ), 'multiple' => '', 'webkitdirectory' => '', 'onchange' => '' ) ) );

		}
	}

	if( $mode == ShowOperateOptionsMode_Post || $mode == ShowOperateOptionsMode_Batch_Operate || $mode == ShowOperateOptionsMode_Settings )
	{
		echo( Ui::SettBlock_Begin( array( 'class' => $settBlockClass ) ) );
		{
			if( $mode == ShowOperateOptionsMode_Post )
			{
				echo( Ui::SettBlock_Item_Begin( _x( 'SrcFileLbl', 'admin.PostUpdater_Operation', 'seraphinite-post-docx-source' ) . Ui::AdminHelpBtn( Plugin::RmtCfgFld_GetLoc( $rmtCfg, 'Help.' . ( _IsGutenbergPage() ? 'InplaceGtnbrgFileSource' : 'InplaceFileSource' ) ), Ui::AdminHelpBtnModeText ) ) );
				{
					echo( Ui::SettBlock_ItemSubTbl_Begin( array( 'class' => 'std', 'style' => array( 'width' => '100%' ) ) ) . Ui::TagOpen( 'tr' ) );
					{
						echo( Ui::Tag( 'td', Ui::Button( _x( 'BrowseBtn', 'admin.PostUpdater_Operation', 'seraphinite-post-docx-source' ), false, null, null, 'button', array( 'onclick' => 'seraph_pds_upload.click();' ) ), array( 'style' => array( 'width' => '1px' ) ) ) );
						echo( Ui::Tag( 'td', Ui::TextBox( 'seraph_pds_filename', null, array( 'style' => array( 'width' => '100%' ), 'readonly' => '' ) ) ) );
					}
					echo( Ui::TagClose( 'tr' ) . Ui::SettBlock_ItemSubTbl_End() );
				}
				echo( Ui::SettBlock_Item_End() );
			}

			if( $mode == ShowOperateOptionsMode_Batch_Operate || $mode == ShowOperateOptionsMode_Settings )
			{
				echo( Ui::SettBlock_Item_Begin( $mode == ShowOperateOptionsMode_Settings ? _x( 'ContentTypeLbl', 'admin.Settings_ContentConversion', 'seraphinite-post-docx-source' ) : ( _x( 'SrcFilesLbl', 'admin.PostUpdater_Operation_Direct', 'seraphinite-post-docx-source' ) . Ui::AdminHelpBtn( Plugin::RmtCfgFld_GetLoc( $rmtCfg, 'Help.DirectFileSources' ), Ui::AdminHelpBtnModeText ) ) ) );
				{
					echo( Ui::SettBlock_ItemSubTbl_Begin( array( 'class' => 'std', 'style' => array( 'width' => '100%' ) ) ) );
					{
						echo( Ui::TagOpen( 'tr' ) );
						{
							echo( Ui::TagOpen( 'td' ) );
							{
?>

								<script>
									function seraph_pds_postType_Set( v )
									{
										jQuery( ".seraph_pds_settBlock" ).hide();
										jQuery( "#seraph_pds_settBlock_" + v ).show();
									}
								</script>

								<?php

								echo( Ui::SettBlock_ItemSubTbl_Begin() . Ui::TagOpen( 'tr' ) );
								{
									{
										$items = array();
										foreach( $aPostTypes as $postType )
											$items[ $postType ] = get_post_type_object( $postType ) -> labels -> name;

										echo( Ui::Tag( 'td', Ui::ComboBox( 'seraph_pds_postType', $items, 'post', false, array( 'style' => array( 'min-width' => '10em' ), 'onchange' => 'seraph_pds_postType_Set( this.selectedIndex >= 0 ? this.options[ this.selectedIndex ].value : \'\' );' ) ) ) );
									}

									if( $mode == ShowOperateOptionsMode_Batch_Operate )
									{
										echo( Ui::Tag( 'td', Ui::Button( _x( 'BrowseBtn', 'admin.PostUpdater_Operation', 'seraphinite-post-docx-source' ), false, null, null, 'button', array( 'onclick' => 'seraph_pds_upload.click();' ) ) ) );
										echo( Ui::Tag( 'td', Ui::Button( _x( 'BrowseFolderBtn', 'admin.PostUpdater_Operation_Direct', 'seraphinite-post-docx-source' ), false, null, null, 'button', array( 'class' => array( 'showIfDirBrowseEnabled' ), 'onclick' => 'seraph_pds_uploadDir.click();' ) ) ) );
									}
								}
								echo( Ui::TagClose( 'tr' ) . Ui::SettBlock_ItemSubTbl_End() );
							}
							echo( Ui::TagClose( 'td' ) );
						}
						echo( Ui::TagClose( 'tr' ) );

						if( $mode == ShowOperateOptionsMode_Batch_Operate )
						{
							echo( Ui::TagOpen( 'tr' ) );
							{
								echo( Ui::TagOpen( 'td' ) );
								{
									echo( Ui::Tag( 'textarea', null, array( 'style' => array( 'width' => '100%', 'min-height' => '7em', 'max-height' => '30em' ), 'id' => 'seraph_pds_filenames', 'type' => 'text', 'readonly' => '' ) ) );
								}
								echo( Ui::TagClose( 'td' ) );
							}
							echo( Ui::TagClose( 'tr' ) );
						}
					}
					echo( Ui::SettBlock_ItemSubTbl_End() );
				}
				echo( Ui::SettBlock_Item_End() );
			}

			if( $mode == ShowOperateOptionsMode_Post || $mode == ShowOperateOptionsMode_Batch_Operate )
			{
				echo( Ui::SettBlock_Item_Begin( _x( 'ExtMediaLbl', 'admin.PostUpdater_Operation', 'seraphinite-post-docx-source' ) . Ui::AdminHelpBtn( Plugin::RmtCfgFld_GetLoc( $rmtCfg, 'Help.LinkedExternalMedia' ), Ui::AdminHelpBtnModeText ) ) );
				{
					echo( Ui::SettBlock_ItemSubTbl_Begin( array( 'class' => array( 'std', 'showIfDirBrowseEnabled' ), 'style' => array( 'width' => '100%' ) ) ) . Ui::TagOpen( 'tr' ) );
					{
						echo( Ui::Tag( 'td', Ui::Button( _x( 'BrowseMediaFolderBtn', 'admin.PostUpdater_Operation', 'seraphinite-post-docx-source' ), false, null, null, 'button', array( 'onclick' => 'seraph_pds_uploadMedias.click();' ) ), array( 'style' => array( 'width' => '1px' ) ) ) );
						echo( Ui::Tag( 'td', Ui::TextBox( 'seraph_pds_uploadMediasPath', null, array( 'style' => array( 'width' => '100%' ), 'readonly' => '' ) ), array( 'style' => array( 'width' => '100%' ) ) ) );
					}
					echo( Ui::TagClose( 'tr' )  . Ui::SettBlock_ItemSubTbl_End() );

					echo( Ui::Tag( 'p', _x( 'ExtMediaNotice', 'admin.PostUpdater_Operation', 'seraphinite-post-docx-source' ), array( 'class' => array( 'description', 'hideIfDirBrowseEnabled' ) ) ) );
				}
				echo( Ui::SettBlock_Item_End() );
			}
		}
		echo( Ui::SettBlock_End() );
	}

	if( $mode == ShowOperateOptionsMode_Post )
		_ShowOperateOptionsBlockForPostType( $mode, $post -> post_type, $postIsNew, $rmtCfg, $sett, $settBlockClass, $availablePlugins, $post );
	else if( $mode == ShowOperateOptionsMode_Settings || $mode == ShowOperateOptionsMode_Batch_Settings )
	{
		foreach( $aPostTypes as $postType )
			_ShowOperateOptionsBlockForPostType( $mode, $postType, $postIsNew, $rmtCfg, $sett, $settBlockClass, $availablePlugins );

		echo( Ui::Tag( 'script', 'seraph_pds_postType_Set( "' . ( empty( $aPostTypes ) ? '' : $aPostTypes[ 0 ] ) . '" );' ) );
	}

	if( $mode == ShowOperateOptionsMode_Post || $mode == ShowOperateOptionsMode_Batch_Operate )
	{
		echo( Ui::TagOpen( 'p' ) );
		{
			echo( Ui::Button( $mode == ShowOperateOptionsMode_Post ? _x( 'UpdateBtn', 'admin.PostUpdater_Operation', 'seraphinite-post-docx-source' ) : _x( 'UpdateAddBtn', 'admin.PostUpdater_Operation_Direct', 'seraphinite-post-docx-source' ), $mode != ShowOperateOptionsMode_Post, 'seraph_pds_reload', null, 'button', array( 'style' => array( 'margin-right' => '0.7em', 'min-width' => '7em', 'vertical-align' => 'middle' ) ) ) );
			echo( Ui::Tag( 'span', null, array( 'id' => 'seraph_pds_loading', 'class' => array( 'seraph_pds_spinner' ), 'style' => array( 'display' => 'none', 'vertical-align' => 'middle' ) ) ) );
		}
		echo( Ui::TagClose( 'p' ) );
	}

	if( $mode == ShowOperateOptionsMode_Post || $mode == ShowOperateOptionsMode_Batch_Report )
	{
		echo( Ui::TagOpen( 'div' ) );
		{
			$heightMin = ( $mode == ShowOperateOptionsMode_Post ? '7' : '14' ) . 'em';

			if( $mode == ShowOperateOptionsMode_Post )
				echo( Ui::Tag( 'div', Ui::Tag( 'strong', _x( 'ReportLbl', 'admin.PostUpdater', 'seraphinite-post-docx-source' ) ), array( 'style' => array( 'margin-bottom' => '0.5em' ) ) ) );
			echo( Ui::Tag( 'div', null, array( 'id' => 'seraph_pds_messages', 'class' => 'seraph_pds_textarea', 'style' => array( 'overflow' => 'scroll', 'min-height' => $heightMin, 'height' => $heightMin, 'max-height' => ( ( $mode == ShowOperateOptionsMode_Post ? '20' : '100' ) . 'em' ), 'resize' => 'vertical' ) ) ) );
		}
		echo( Ui::TagClose( 'div' ) );
	}
}

function _ShowOperateOptionsBlockForPostType( $mode, $postType, $postIsNew, $rmtCfg, $sett, $settBlockClass, $availablePlugins, $post = NULL )
{
	$settBlockClass[] = 'seraph_pds_settBlock';

	echo( Ui::SettBlock_Begin( array( 'id' => ( 'seraph_pds_settBlock_' . $postType ), 'class' => $settBlockClass ) ) );
	{
		echo( Ui::SettBlock_Item_Begin( _x( 'Lbl', 'admin.Settings_ContentConversion_Document', 'seraphinite-post-docx-source' ) . Ui::AdminBtnsBlock( array( $mode == ShowOperateOptionsMode_Settings ? Plugin::AdminBtnsBlock_GetPaidContent() : null ), Ui::AdminHelpBtnModeText ) ) );
		{
			echo( Ui::SettBlock_ItemSubTbl_Begin() );

			{
				$fldId = 'docTypes/' . $postType . '/useSubjectAsID';
				echo( Ui::Tag( 'tr', Ui::Tag( 'td', Ui::CheckBox( _x( 'BindChk', 'admin.Settings_ContentConversion_Document', 'seraphinite-post-docx-source' ) . Ui::AdminHelpBtn( Plugin::RmtCfgFld_GetLoc( $rmtCfg, 'Help.PostIdBinding' ), Ui::AdminHelpBtnModeChkRad ), 'seraph_pds/' . $fldId, Gen::GetArrField( $sett, $fldId, false, '/' ), $mode == ShowOperateOptionsMode_Settings ) ) ) );
			}

			{
				$fldId = 'docTypes/' . $postType . '/useSeparateAttributes';
				echo( Ui::Tag( 'tr', Ui::Tag( 'td', Ui::CheckBox( _x( 'AttrsChk', 'admin.Settings_ContentConversion_Document', 'seraphinite-post-docx-source' ) . Ui::AdminHelpBtn( Plugin::RmtCfgFld_GetLoc( $rmtCfg, 'Help.SeparateAttributes' ), Ui::AdminHelpBtnModeChkRad ), 'seraph_pds/' . $fldId, Gen::GetArrField( $sett, $fldId, true, '/' ), $mode == ShowOperateOptionsMode_Settings ) ) ) );
			}

			{
				$rowAtrs = array();

				$ctlVal = Gen::GetArrField( $sett, $fldId, true, '/' );

				if( !_IsGutenbergActive() )
				{
					$rowAtrs[ 'style' ] = array( 'display' => 'none' );
					$ctlVal = false;
				}

				if( ( $mode == ShowOperateOptionsMode_Post && !_IsGutenbergPage() ) || ( $mode == ShowOperateOptionsMode_Batch_Settings && !_IsGutenbergDefault( $postType ) ) )
					$ctlVal = false;

				$fldId = 'docTypes/' . $postType . '/useGtnbrgFormat';
				echo( Ui::Tag( 'tr', Ui::Tag( 'td', Ui::CheckBox( _x( 'GutenbergChk', 'admin.Settings_ContentConversion_Document', 'seraphinite-post-docx-source' ) . Ui::AdminHelpBtn( Plugin::RmtCfgFld_GetLoc( $rmtCfg, 'Help.GtnbrgBodyBlocks' ), Ui::AdminHelpBtnModeChkRad ), 'seraph_pds/' . $fldId, $ctlVal, $mode == ShowOperateOptionsMode_Settings ) ), $rowAtrs ) );
			}

			echo( Ui::SettBlock_ItemSubTbl_End() );
		}
		echo( Ui::SettBlock_Item_End() );

		echo( Ui::SettBlock_Item_Begin( _x( 'Lbl', 'admin.Settings_ContentConversion_Links', 'seraphinite-post-docx-source' ) . Ui::AdminBtnsBlock( array( array( 'type' => Ui::AdminBtn_Help, 'href' => Plugin::RmtCfgFld_GetLoc( $rmtCfg, 'Help.NonExistentLinks' ) ), $mode == ShowOperateOptionsMode_Settings ? Plugin::AdminBtnsBlock_GetPaidContent() : null ), Ui::AdminHelpBtnModeText ) ) );
		{
			echo( Ui::SettBlock_ItemSubTbl_Begin() );
			{
				$fldId = 'docTypes/' . $postType . '/notexistLinksAction'; $groupName = 'seraph_pds/' . $fldId; $fldVal = Gen::GetArrField( $sett, $fldId, 'Underline', '/' );

?>

				<tr>
					<td>
						<?php echo( Ui::RadioBox( _x( 'UnderlineChk', 'admin.Settings_ContentConversion_Links', 'seraphinite-post-docx-source' ), $groupName, 'Underline', $fldVal == 'Underline' ) ); ?>
					</td>
					<td>
						<?php echo( Ui::RadioBox( _x( 'CheckOnlyChk', 'admin.Settings_ContentConversion_Links', 'seraphinite-post-docx-source' ), $groupName, 'CheckOnly', $fldVal == 'CheckOnly' ) ); ?>
					</td>
				</tr>
				<tr>
					<td>
						<?php echo( Ui::RadioBox( _x( 'DelChk', 'admin.Settings_ContentConversion_Links', 'seraphinite-post-docx-source' ), $groupName, 'Del', $fldVal == 'Del' ) ); ?>
					</td>
					<td>
						<?php echo( Ui::RadioBox( _x( 'NoChk', 'admin.Settings_ContentConversion_Links', 'seraphinite-post-docx-source' ), $groupName, 'No', $fldVal == 'No' ) ); ?>
					</td>
				</tr>
				<?php
			}
			echo( Ui::SettBlock_ItemSubTbl_End() );
		}
		echo( Ui::SettBlock_Item_End() );

		echo( Ui::SettBlock_Item_Begin( _x( 'Lbl', 'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ) . Ui::AdminBtnsBlock( array( $mode == ShowOperateOptionsMode_Settings ? Plugin::AdminBtnsBlock_GetPaidContent() : null ), Ui::AdminHelpBtnModeText ) ) );
		{
			echo( Ui::SettBlock_ItemSubTbl_Begin() );
			{
				?>
				<tr>
					<td>
						<?php

						$fldId = 'docTypes/' . $postType . '/useTitle';

						$fldSubId = 'docTypes/' . $postType . '/useTitle_Mode';
						$fldSubVal = Gen::GetArrField( $sett, $fldSubId, 'Body', '/' );

						echo( Ui::CheckBox(
							array(
								_x( 'TitleChk_%1$s', 'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ) . Ui::AdminHelpBtn( Plugin::RmtCfgFld_GetLoc( $rmtCfg, 'Help.Title' ), Ui::AdminHelpBtnModeChkRad ),
								array(
									array(
										'seraph_pds/' . $fldSubId,
										array(
											array( 'Body',			_x( 'TitleChk_1_Body',			'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ),			$fldSubVal == 'Body' ),
											array( 'Prop,Body',		_x( 'TitleChk_1_PropBody',		'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ),			$fldSubVal == 'Prop,Body' ),
											array( 'Prop',			_x( 'TitleChk_1_Prop',			'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ),			$fldSubVal == 'Prop' )
										)
									)
								)
							),
							'seraph_pds/' . $fldId,
							Gen::GetArrField( $sett, $fldId, true, '/' ),
							$mode == ShowOperateOptionsMode_Settings
						) );
						?>
					</td>
					<td>
						<?php

						$fldId = 'docTypes/' . $postType . '/useTags';

						$fldSubId = 'docTypes/' . $postType . '/useTags_Mode';
						$fldSubVal = Gen::GetArrField( $sett, $fldSubId, 'Prop,Body', '/' );

						echo( Ui::CheckBox(
							array(
								_x( 'TagsChk_%1$s', 'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ) . Ui::AdminHelpBtn( Plugin::RmtCfgFld_GetLoc( $rmtCfg, 'Help.Tags' ), Ui::AdminHelpBtnModeChkRad ),
								array(
									array(
										'seraph_pds/' . $fldSubId,
										array(
											array( 'Body',			_x( 'TagsChk_1_Body',			'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ),			$fldSubVal == 'Body' ),
											array( 'Prop,Body',		_x( 'TagsChk_1_PropBody',			'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ),			$fldSubVal == 'Prop,Body' ),
											array( 'Prop',			_x( 'TagsChk_1_Prop',			'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ),			$fldSubVal == 'Prop' )
										)
									)
								)
							),
							'seraph_pds/' . $fldId,
							Gen::GetArrField( $sett, $fldId, true, '/' ),
							$mode == ShowOperateOptionsMode_Settings
						) );

						?>
					</td>
					<td>
						<?php

						$fldId = 'docTypes/' . $postType . '/useSeoTitle';

						$fldSubId = 'docTypes/' . $postType . '/useSeoTitle_Mode';
						$fldSubVal = Gen::GetArrField( $sett, $fldSubId, 'Prop,Body', '/' );

						echo( Ui::CheckBox(
							array(
								_x( 'SeoTitleChk_%1$s', 'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ) . Ui::AdminHelpBtn( Plugin::RmtCfgFld_GetLoc( $rmtCfg, 'Help.SeoTitle' ), Ui::AdminHelpBtnModeChkRad ),
								array(
									array(
										'seraph_pds/' . $fldSubId,
										array(
											array( 'Body',			_x( 'SeoTitleChk_1_Body',			'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ),			$fldSubVal == 'Body' ),
											array( 'Prop,Body',		_x( 'SeoTitleChk_1_PropBody',			'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ),			$fldSubVal == 'Prop,Body' ),
											array( 'Prop',			_x( 'SeoTitleChk_1_Prop',			'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ),			$fldSubVal == 'Prop' )
										)
									)
								)
							),
							'seraph_pds/' . $fldId,
							Gen::GetArrField( $sett, $fldId, true, '/' ),
							$mode == ShowOperateOptionsMode_Settings
						) );

						?>
					</td>
				</tr>
				<tr>
					<td>
						<?php

						$fldId = 'docTypes/' . $postType . '/useExcerpt';

						$fldSubId = 'docTypes/' . $postType . '/useExcerpt_Mode';
						$fldSubVal = Gen::GetArrField( $sett, $fldSubId, 'Body', '/' );

						echo( Ui::CheckBox(
							array(
								_x( 'ExcerptChk_%1$s', 'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ) . Ui::AdminHelpBtn( Plugin::RmtCfgFld_GetLoc( $rmtCfg, 'Help.Excerpt' ), Ui::AdminHelpBtnModeChkRad ),
								array(
									array(
										'seraph_pds/' . $fldSubId,
										array(
											array( 'Body',			_x( 'ExcerptChk_1_Body',			'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ),		$fldSubVal == 'Body' ),
											array( 'Prop,Body',		_x( 'ExcerptChk_1_PropBody',			'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ),		$fldSubVal == 'Prop,Body' ),
											array( 'Prop',			_x( 'ExcerptChk_1_Prop',			'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ),		$fldSubVal == 'Prop' )
										)
									)
								)
							),
							'seraph_pds/' . $fldId,
							Gen::GetArrField( $sett, $fldId, true, '/' ),
							$mode == ShowOperateOptionsMode_Settings
						) );

						?>
					</td>
					<td>
						<?php

						$fldId = 'docTypes/' . $postType . '/useCategories';

						$fldSubId = 'docTypes/' . $postType . '/useCategories_Mode';
						$fldSubVal = Gen::GetArrField( $sett, $fldSubId, 'Prop,Body', '/' );

						echo( Ui::CheckBox(
							array(
								_x( 'CategoriesChk_%1$s', 'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ) . Ui::AdminHelpBtn( Plugin::RmtCfgFld_GetLoc( $rmtCfg, 'Help.Categories' ), Ui::AdminHelpBtnModeChkRad ),
								array(
									array(
										'seraph_pds/' . $fldSubId,
										array(
											array( 'Body',			_x( 'CategoriesChk_1_Body',			'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ),		$fldSubVal == 'Body' ),
											array( 'Prop,Body',		_x( 'CategoriesChk_1_PropBody',			'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ),		$fldSubVal == 'Prop,Body' ),
											array( 'Prop',			_x( 'CategoriesChk_1_Prop',			'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ),		$fldSubVal == 'Prop' )
										)
									)
								)
							),
							'seraph_pds/' . $fldId,
							Gen::GetArrField( $sett, $fldId, true, '/' ),
							$mode == ShowOperateOptionsMode_Settings
						) );

						?>
					</td>
					<td>
						<?php

						$fldId = 'docTypes/' . $postType . '/useSeoDescription';

						$fldSubId = 'docTypes/' . $postType . '/useSeoDescription_Mode';
						$fldSubVal = Gen::GetArrField( $sett, $fldSubId, 'Prop,Body', '/' );

						echo( Ui::CheckBox(
							array(
								_x( 'SeoDescrChk_%1$s', 'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ) . Ui::AdminHelpBtn( Plugin::RmtCfgFld_GetLoc( $rmtCfg, 'Help.SeoDescription' ), Ui::AdminHelpBtnModeChkRad ),
								array(
									array(
										'seraph_pds/' . $fldSubId,
										array(
											array( 'Body',			_x( 'SeoDescrChk_1_Body',			'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ),		$fldSubVal == 'Body' ),
											array( 'Prop,Body',		_x( 'SeoDescrChk_1_PropBody',			'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ),		$fldSubVal == 'Prop,Body' ),
											array( 'Prop',			_x( 'SeoDescrChk_1_Prop',			'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ),		$fldSubVal == 'Prop' )
										)
									)
								)
							),
							'seraph_pds/' . $fldId,
							Gen::GetArrField( $sett, $fldId, true, '/' ),
							$mode == ShowOperateOptionsMode_Settings
						) );

						?>
					</td>
				</tr>
				<tr>
					<td>
						<?php

						$fldId = 'docTypes/' . $postType . '/useSlug';

						$fldSubId = 'docTypes/' . $postType . '/useSlug_Mode';
						$fldSubVal = Gen::GetArrField( $sett, $fldSubId, 'Body', '/' );

						echo( Ui::CheckBox(
							array(
								_x( 'SlugChk_%1$s', 'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ) . Ui::AdminHelpBtn( Plugin::RmtCfgFld_GetLoc( $rmtCfg, 'Help.Slug' ), Ui::AdminHelpBtnModeChkRad ),
								array(
									array(
										'seraph_pds/' . $fldSubId,
										array(
											array( 'Body',			_x( 'SlugChk_1_Body',			'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ),			$fldSubVal == 'Body' ),
											array( 'Prop,Body',		_x( 'SlugChk_1_PropBody',			'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ),			$fldSubVal == 'Prop,Body' ),
											array( 'Prop',			_x( 'SlugChk_1_Prop',			'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ),			$fldSubVal == 'Prop' )
										)
									)
								)
							),
							'seraph_pds/' . $fldId,
							Gen::GetArrField( $sett, $fldId, true, '/' ),
							$mode == ShowOperateOptionsMode_Settings
						) );

						?>
					</td>
					<td>
						<?php

						$fldId = 'docTypes/' . $postType . '/useFeaturedImage';

						echo( Ui::CheckBox(
							_x( 'FeaturedImageChk', 'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ) . Ui::AdminHelpBtn( Plugin::RmtCfgFld_GetLoc( $rmtCfg, 'Help.FeaturedImage' ), Ui::AdminHelpBtnModeChkRad ),
							'seraph_pds/' . $fldId,
							Gen::GetArrField( $sett, $fldId, true, '/' ),
							$mode == ShowOperateOptionsMode_Settings
						) );

						?>
					</td>
					<td>
						<?php

						$isLangsActive = Wp::IsLangsActive();

						$fldId = 'docTypes/' . $postType . '/useLang';

						$fldSubId = 'docTypes/' . $postType . '/useLang_Mode';
						$fldSubVal = Gen::GetArrField( $sett, $fldSubId, 'Body', '/' );

						echo( Ui::CheckBox(
							array(
								_x( 'LangChk_%1$s', 'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ) . Ui::AdminHelpBtn( Plugin::RmtCfgFld_GetLoc( $rmtCfg, 'Help.Lang' ), Ui::AdminHelpBtnModeChkRad ),
								array(
									array(
										'seraph_pds/' . $fldSubId,
										array(
											array( 'Body',			_x( 'LangChk_1_Body',			'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ),			$fldSubVal == 'Body' ),
											array( 'Prop,Body',		_x( 'LangChk_1_PropBody',		'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ),			$fldSubVal == 'Prop,Body' ),
											array( 'Prop',			_x( 'LangChk_1_Prop',			'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ),			$fldSubVal == 'Prop' )
										)
									)
								)
							),
							'seraph_pds/' . $fldId,
							$isLangsActive ? Gen::GetArrField( $sett, $fldId, true, '/' ) : false,
							$mode == ShowOperateOptionsMode_Settings,
							$isLangsActive ? null : array( 'style' => array( 'display' => 'none' ) )
						) );

						?>
					</td>
				</tr>
				<?php

				echo( Ui::TagOpen( 'tr' ) );
				{
					echo( Ui::TagOpen( 'td' ) );
					{
						$showOpt =
							$postType == 'product' &&
							in_array( 'woocommerce', $availablePlugins ) &&
							$mode != ShowOperateOptionsMode_Post;

						$fldId = 'docTypes/' . $postType . '/useWooGalleryImages';

						echo( Ui::CheckBox(
							_x( 'WooGalleryImagesChk', 'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ) . Ui::AdminHelpBtn( Plugin::RmtCfgFld_GetLoc( $rmtCfg, 'Help.WooGalleryImages' ), Ui::AdminHelpBtnModeChkRad ),
							'seraph_pds/' . $fldId,
							$showOpt ? Gen::GetArrField( $sett, $fldId, true, '/' ) : false,
							$mode == ShowOperateOptionsMode_Settings,
							$showOpt ? null : array( 'style' => array( 'display' => 'none' ) )
						) );
					}
					echo( Ui::TagClose( 'td' ) );
				}
				echo( Ui::TagClose( 'tr' ) );
			}
			echo( Ui::SettBlock_ItemSubTbl_End() );
		}
		echo( Ui::SettBlock_Item_End() );

		echo( Ui::SettBlock_Item_Begin( '' ) );
		{
			$fldId = 'docTypes/' . $postType . '/useInplaceAttrs';

			echo( Ui::CheckBox(
					_x( 'CustomChk', 'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ) . Ui::AdminHelpBtn( Plugin::RmtCfgFld_GetLoc( $rmtCfg, 'Help.OtherH1ExtAttrs' ), Ui::AdminHelpBtnModeChkRad ),
					'seraph_pds/' . $fldId,
					Gen::GetArrField( $sett, $fldId, true, '/' ),
					$mode == ShowOperateOptionsMode_Settings
			) );

			if( $mode == ShowOperateOptionsMode_Post && !_IsGutenbergPage() )
				echo( Ui::Tag( 'p', sprintf( _x( 'PageControlsForBlocksListInfo_%1$s', 'admin.Settings_ContentConversion_Attrs', 'seraphinite-post-docx-source' ), Ui::Tag( 'span', null, array( 'id' => 'seraph_pds/docTypes/' . $postType . '/useInplaceAttrsText' ) ) ), array( 'class' => 'description' ) ) );
		}
		echo( Ui::SettBlock_Item_End() );

		echo( Ui::SettBlock_Item_Begin( _x( 'Lbl', 'admin.Settings_ContentConversion_Media', 'seraphinite-post-docx-source' ) . Ui::AdminBtnsBlock( array( array( 'type' => Ui::AdminBtn_Help, 'href' => Plugin::RmtCfgFld_GetLoc( $rmtCfg, 'Help.Media' ) ), $mode == ShowOperateOptionsMode_Settings ? Plugin::AdminBtnsBlock_GetPaidContent() : null ), Ui::AdminHelpBtnModeText ) ) );
		{
			echo( Ui::SettBlock_ItemSubTbl_Begin() );
			{
?>
				<tr>
					<td>
						<?php

						$fldId = 'docTypes/' . $postType . '/uploadMedia';

						echo( Ui::CheckBox(
							_x( 'UploadChk', 'admin.Settings_ContentConversion_Media', 'seraphinite-post-docx-source' ) . Ui::AdminHelpBtn( Plugin::RmtCfgFld_GetLoc( $rmtCfg, 'Help.UploadMedia' ), Ui::AdminHelpBtnModeChkRad ),
							'seraph_pds/' . $fldId,
							$postIsNew ? false : Gen::GetArrField( $sett, $fldId, true, '/' ),
							$mode == ShowOperateOptionsMode_Settings
						) );

						?>
					</td>
				</tr>
				<tr>
					<td style="padding-left:1.5em;">
						<?php

						$fldId = 'docTypes/' . $postType . '/uploadOverwrite';

						echo( Ui::CheckBox(
							_x( 'OverwriteChk', 'admin.Settings_ContentConversion_Media', 'seraphinite-post-docx-source' ) . Ui::AdminHelpBtn( Plugin::RmtCfgFld_GetLoc( $rmtCfg, 'Help.UploadMediaOverwrite' ), Ui::AdminHelpBtnModeChkRad ),
							'seraph_pds/' . $fldId,
							Gen::GetArrField( $sett, $fldId, false, '/' ),
							$mode == ShowOperateOptionsMode_Settings
						) );

						?>
					</td>
				</tr>
				<tr>
					<td style="padding-left:1.5em;">
						<?php

						{
							$fldId = 'docTypes/' . $postType . '/uploadAsAttachments';

							echo( Ui::CheckBox(
								_x( 'PlaceToLibChk', 'admin.Settings_ContentConversion_Media', 'seraphinite-post-docx-source' ) . Ui::AdminHelpBtn( Plugin::RmtCfgFld_GetLoc( $rmtCfg, 'Help.PlaceIntoMediaLibrary' ), Ui::AdminHelpBtnModeChkRad ),
								'seraph_pds/' . $fldId,
								Gen::GetArrField( $sett, $fldId, true, '/' ),
								$mode == ShowOperateOptionsMode_Settings
							) );
						}

						?>
					</td>
				</tr>

				<tr>
					<td style="padding-left:3em;">
						<?php

						{
							$subFldId = 'docTypes/' . $postType . '/imagesAsThumb';

							$items = array();
							{
								$aThumbnails = Wp::GetAvailableThumbnails();

								$items[ '' ] = _x( 'ImgSizeCmb_Original', 'admin.Settings_ContentConversion_Media', 'seraphinite-post-docx-source' );
								foreach( $aThumbnails as $thumbnailId => $thumbnail )
								{
									$cx = $thumbnail[ 'width' ];
									$cy = $thumbnail[ 'height' ];
									$items[ $thumbnailId ] = $thumbnail[ 'name' ] . ' (' . ( $cx ? $cx : '*' ) . 'x' . ( $cy ? $cy : '*' ) .  ')';
								}
							}

							echo( Ui::Tag( 'label',
								Ui::EscHtml( _x( 'ImgSizeLbl', 'admin.Settings_ContentConversion_Media', 'seraphinite-post-docx-source' ), true ) .
								Ui::ComboBox(
									'seraph_pds/' . $subFldId,
									$items,
									Gen::GetArrField( $sett, $subFldId, '', '/' ),
									$mode == ShowOperateOptionsMode_Settings
								) .
								Ui::AdminHelpBtn( Plugin::RmtCfgFld_GetLoc( $rmtCfg, 'Help.ImgFilenameSize' ), Ui::AdminHelpBtnModeEdit )
							) );
						}

						?>
					</td>
				</tr>

				<tr>
					<td>
						<?php

						echo( Ui::SettBlock_ItemSubTbl_Begin() . Ui::TagOpen( 'tr' ) );

						{
							$fldId = 'docTypes/' . $postType . '/imageUseDescrAsFilename';

							echo( Ui::Tag( 'td', Ui::CheckBox(
								_x( 'ImgDescrAsFileNameChk', 'admin.Settings_ContentConversion_Media', 'seraphinite-post-docx-source' ) . Ui::AdminHelpBtn( Plugin::RmtCfgFld_GetLoc( $rmtCfg, 'Help.MediaDescrAsFilename' ), Ui::AdminHelpBtnModeChkRad ),
								'seraph_pds/' . $fldId,
								Gen::GetArrField( $sett, $fldId, false, '/' ),
								$mode == ShowOperateOptionsMode_Settings
							) ) );
						}

						{
							$fldId = 'docTypes/' . $postType . '/mediaPrependSlugToFileName';

							echo( Ui::Tag( 'td', Ui::CheckBox(
								_x( 'PrependSlugToFileNamesChk', 'admin.Settings_ContentConversion_Media', 'seraphinite-post-docx-source' ) . Ui::AdminHelpBtn( Plugin::RmtCfgFld_GetLoc( $rmtCfg, 'Help.MediaPrependDocSlug' ), Ui::AdminHelpBtnModeChkRad ),
								'seraph_pds/' . $fldId,
								Gen::GetArrField( $sett, $fldId, false, '/' ),
								$mode == ShowOperateOptionsMode_Settings
							) ) );
						}

						echo( Ui::TagClose( 'tr' ) . Ui::SettBlock_ItemSubTbl_End() );

						?>
					</td>
				</tr>

				<?php

				echo( Ui::TagOpen( 'tr' ) . Ui::TagOpen( 'td' ) );
				{
					$fldId = 'docTypes/' . $postType . '/uploadImageCheckUrl';

					echo( Ui::CheckBox(
						_x( 'CheckUrlsChk', 'admin.Settings_ContentConversion_Media', 'seraphinite-post-docx-source' ) . Ui::AdminHelpBtn( Plugin::RmtCfgFld_GetLoc( $rmtCfg, 'Help.MediaCheckUrls' ), Ui::AdminHelpBtnModeChkRad ),
						'seraph_pds/' . $fldId,
						$postIsNew ? false : Gen::GetArrField( $sett, $fldId, true, '/' ),
						$mode == ShowOperateOptionsMode_Settings
					) );
				}
				echo( Ui::TagClose( 'td' ) . Ui::TagClose( 'tr' ) );
			}
			echo( Ui::SettBlock_ItemSubTbl_End() );

			if( $postIsNew )
				echo( Ui::Tag( 'p', vsprintf( _x( 'NewPostNoticeInfo_%1$s%2$s', 'admin.Settings_ContentConversion_Media', 'seraphinite-post-docx-source' ), Ui::Tag( 'span', array( '', '' ) ) ), array( 'class' => 'description' ) ) );
		}
		echo( Ui::SettBlock_Item_End() );

		echo( Ui::SettBlock_Item_Begin( _x( 'MediaUrlLbl', 'admin.Settings_ContentConversion_Media', 'seraphinite-post-docx-source' ) . Ui::AdminBtnsBlock( array( array( 'type' => Ui::AdminBtn_Help, 'href' => Plugin::RmtCfgFld_GetLoc( $rmtCfg, 'Help.MediaURLBase' ) ), $mode == ShowOperateOptionsMode_Settings ? Plugin::AdminBtnsBlock_GetPaidContent() : null ), Ui::AdminHelpBtnModeText ) ) );
		{
			echo( Ui::SettBlock_ItemSubTbl_Begin( array( 'class' => 'ctlMaxSizeX' ) ) );
			{
				if( $mode == ShowOperateOptionsMode_Post )
				{
					echo( Ui::TagOpen( 'tr' ) . Ui::TagOpen( 'td' ) );
					{
						echo( Ui::TextBox( 'seraph_pds_post-media-url', Wp::GetMediaUploadUrl( $post, true ), array( 'style' => array( 'width' => '100%' ) ) ) );
					}
					echo( Ui::TagClose( 'td' ) . Ui::TagClose( 'tr' ) );
				}

			}
			echo( Ui::SettBlock_ItemSubTbl_End() );
		}
		echo( Ui::SettBlock_Item_End() );
	}
	echo( Ui::SettBlock_End() );
}

function OnOptRead_Data( $data, $verFrom )
{
	return( $data );
}

function OnOptWrite_Data( $data )
{
	return( $data );
}

function OnOptRead_Sett( $sett, $verFrom )
{
	return( $sett );
}

function OnOptWritePrep_Sett( $sett )
{
	$postTypes = GetCompatiblePostsTypes();

	$atLeastOneEnabled = false;
	foreach( $postTypes as $postType )
		if( Gen::GetArrField( $sett, array( 'docTypes', $postType, 'enable' ), false ) )
			$atLeastOneEnabled = true;

	if( !$atLeastOneEnabled && count( $postTypes ) )
		Gen::SetArrField( $sett, array( 'docTypes', $postTypes[ 0 ], 'enable' ), true );

	return( $sett );
}

function getUrl( $url, $body = false )
{

	$prms = array( 'sslverify' => false );

	$requestRes = $body ? wp_remote_get( $url, $prms ) : wp_remote_head( $url, $prms );
	if( is_wp_error( $requestRes ) )
		return( array( 'hr' => Gen::E_FAIL ) );

	$httpStatus = wp_remote_retrieve_response_code( $requestRes );
	if( !( $httpStatus >= 200 && $httpStatus < 400 || $httpStatus == 403 || $httpStatus == 423 ) )
		return( array( 'hr' => Gen::S_FALSE, 'httpCode' => $httpStatus ) );

	$res = array( 'hr' => Gen::S_OK );
	if( $body )
		$res[ 'body' ] = wp_remote_retrieve_body( $requestRes );

	return( $res );
}

function _IsGutenbergPage()
{
	if( Gen::DoesFuncExist( 'is_gutenberg_page' ) )
	    return( is_gutenberg_page() );

	{
		global $current_screen;

		if( !isset( $current_screen ) )
			$current_screen = get_current_screen();

		if( method_exists( $current_screen, 'is_block_editor' ) )
			return( $current_screen -> is_block_editor() );
	}

	return( false );
}

function _IsGutenbergDefault( $postType )
{
	$postCont = Wp::CreateFakePostContainer( $postType );

	if( Gen::DoesFuncExist( 'gutenberg_can_edit_post' ) && gutenberg_can_edit_post( $postCont -> post ) )
		return( true );

	if( Gen::DoesFuncExist( 'use_block_editor_for_post' ) && use_block_editor_for_post( $postCont -> post ) )
		return( true );

	return( false );
}

function _IsGutenbergActive()
{
	$postType = 'post';

	if( Gen::DoesFuncExist( 'gutenberg_can_edit_post_type' ) && gutenberg_can_edit_post_type( $postType ) )
		return( true );

	if( Gen::DoesFuncExist( 'use_block_editor_for_post_type' ) && use_block_editor_for_post_type( $postType ) )
		return( true );

	return( false );
}

